import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { initDomain } from '@resolve-js/core';
import { createQuery } from '@resolve-js/runtime';
import { getSecretsManager } from '../../runtime/get-secrets-manager';
import { getEventStore } from '../../runtime/get-event-store';
import { getReadModelAdapter } from '../../runtime/get-read-model-adapter';
import { defaultAssertion } from '../../utils/assertions';
export var makeTestEnvironment = function makeTestEnvironment(context) {
  var executed = false;
  var authToken;
  var assertion;
  var assertionNegated = false;
  var secretsManager = getSecretsManager();
  var completeTest;
  var failTest;

  var setAuthToken = function setAuthToken(value) {
    authToken = value;
  };

  var setSecretsManager = function setSecretsManager(value) {
    secretsManager = value;
  };

  var setAssertion = function setAssertion(value) {
    assertion = value;
  };

  var getAssertion = function getAssertion() {
    return assertion;
  };

  var negateAssertion = function negateAssertion() {
    assertionNegated = true;
  };

  var isAssertionNegated = function isAssertionNegated() {
    return assertionNegated;
  };

  var isExecuted = function isExecuted() {
    return executed;
  };

  var promise = new Promise(function (resolve, reject) {
    completeTest = resolve;
    failTest = reject;
  });

  var execute = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
      var readModel, events, query, adapter, encryption, actualAdapter, actualEncryption, domain, liveErrors, makeMonitoring, errors, executor, result, actualAssertion, isNext, eventstoreAdapter, status, liveErrorIndex, _error, _yield$executor$read, summaryError;

      return _regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              executed = true;
              readModel = context.readModel, events = context.events, query = context.query, adapter = context.adapter, encryption = context.encryption;

              if (!(adapter != null)) {
                _context4.next = 6;
                break;
              }

              _context4.t0 = adapter;
              _context4.next = 9;
              break;

            case 6:
              _context4.next = 8;
              return getReadModelAdapter();

            case 8:
              _context4.t0 = _context4.sent;

            case 9:
              actualAdapter = _context4.t0;
              actualEncryption = encryption != null ? encryption : /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                return _regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        return _context.abrupt("return", null);

                      case 1:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              domain = initDomain({
                viewModels: [],
                readModels: [{
                  name: readModel.name,
                  projection: readModel.projection,
                  resolvers: readModel.resolvers,
                  connectorName: 'ADAPTER_NAME',
                  encryption: actualEncryption
                }],
                aggregates: [],
                sagas: []
              });
              liveErrors = [];

              makeMonitoring = function makeMonitoring(error, execution) {
                if (error === void 0) {
                  error = function error() {
                    return void 0;
                  };
                }

                if (execution === void 0) {
                  execution = function execution() {
                    return void 0;
                  };
                }

                return {
                  group: function group(config) {
                    var errorHandler = function errorHandler(error) {
                      if (error != null) {
                        liveErrors.push(error);
                      }
                    };

                    return config.Part === 'ReadModelProjection' ? makeMonitoring(errorHandler, errorHandler) : makeMonitoring(error, execution);
                  },
                  time: function time() {
                    return void 0;
                  },
                  timeEnd: function timeEnd() {
                    return void 0;
                  },
                  execution: execution,
                  error: error,
                  publish: function () {
                    var _publish = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
                      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                        while (1) {
                          switch (_context2.prev = _context2.next) {
                            case 0:
                              return _context2.abrupt("return", void 0);

                            case 1:
                            case "end":
                              return _context2.stop();
                          }
                        }
                      }, _callee2);
                    }));

                    function publish() {
                      return _publish.apply(this, arguments);
                    }

                    return publish;
                  }()
                };
              };

              errors = [];
              executor = null;
              result = null;
              actualAssertion = assertion != null ? assertion : defaultAssertion;
              isNext = false;
              _context4.prev = 19;
              _context4.next = 22;
              return getEventStore(events);

            case 22:
              eventstoreAdapter = _context4.sent;
              executor = createQuery({
                applicationName: 'APP_NAME',
                readModelConnectors: {
                  ADAPTER_NAME: actualAdapter
                },
                getVacantTimeInMillis: function getVacantTimeInMillis() {
                  return 0x7fffffff;
                },
                invokeBuildAsync: function () {
                  var _invokeBuildAsync = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
                    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            isNext = true;

                          case 1:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  function invokeBuildAsync() {
                    return _invokeBuildAsync.apply(this, arguments);
                  }

                  return invokeBuildAsync;
                }(),
                eventstoreAdapter: eventstoreAdapter,
                readModelsInterop: domain.readModelDomain.acquireReadModelsInterop({
                  secretsManager: secretsManager,
                  monitoring: makeMonitoring()
                }),
                viewModelsInterop: {},
                performanceTracer: null
              });
              _context4.prev = 24;
              _context4.next = 27;
              return eventstoreAdapter.ensureEventSubscriber({
                applicationName: 'APP_NAME',
                eventSubscriber: readModel.name,
                status: null,
                destination: 'LOCAL'
              });

            case 27:
              _context4.next = 29;
              return executor.subscribe({
                modelName: readModel.name,
                subscriptionOptions: {
                  eventTypes: null,
                  aggregateIds: null
                }
              });

            case 29:
              _context4.next = 31;
              return executor.resume({
                modelName: readModel.name
              });

            case 31:
              isNext = false;
              _context4.next = 34;
              return executor.build({
                modelName: readModel.name
              });

            case 34:
              if (isNext) {
                _context4.next = 31;
                break;
              }

            case 35:
              _context4.next = 37;
              return executor.status({
                modelName: readModel.name
              });

            case 37:
              status = _context4.sent;

              if (!(status.status === 'error')) {
                _context4.next = 49;
                break;
              }

              if (Array.isArray(status.errors)) {
                _context4.next = 41;
                break;
              }

              throw new Error('Unknown error');

            case 41:
              liveErrorIndex = status.errors.length === 1 ? liveErrors.findIndex(function (err) {
                return err.message === status.errors[0].message;
              }) : -1;

              if (!(liveErrorIndex < 0)) {
                _context4.next = 48;
                break;
              }

              _error = new Error(status.errors.map(function (err) {
                return err.message;
              }).join('\n'));
              _error.stack = status.errors.map(function (err) {
                return err.stack;
              }).join('\n');
              throw _error;

            case 48:
              throw liveErrors[liveErrorIndex];

            case 49:
              _context4.next = 54;
              break;

            case 51:
              _context4.prev = 51;
              _context4.t1 = _context4["catch"](24);
              errors.push(_context4.t1);

            case 54:
              _context4.prev = 54;
              _context4.next = 57;
              return executor.read({
                modelName: readModel.name,
                resolverName: query.resolver,
                resolverArgs: query.args,
                jwt: authToken
              });

            case 57:
              _yield$executor$read = _context4.sent;
              result = _yield$executor$read.data;
              void _yield$executor$read;
              _context4.next = 65;
              break;

            case 62:
              _context4.prev = 62;
              _context4.t2 = _context4["catch"](54);
              errors.push(_context4.t2);

            case 65:
              _context4.prev = 65;
              _context4.next = 68;
              return executor.unsubscribe({
                modelName: readModel.name
              });

            case 68:
              _context4.next = 73;
              break;

            case 70:
              _context4.prev = 70;
              _context4.t3 = _context4["catch"](65);
              errors.push(_context4.t3);

            case 73:
              _context4.prev = 73;
              _context4.next = 76;
              return eventstoreAdapter.removeEventSubscriber({
                applicationName: 'APP_NAME',
                eventSubscriber: readModel.name
              });

            case 76:
              _context4.next = 81;
              break;

            case 78:
              _context4.prev = 78;
              _context4.t4 = _context4["catch"](73);
              errors.push(_context4.t4);

            case 81:
              _context4.next = 86;
              break;

            case 83:
              _context4.prev = 83;
              _context4.t5 = _context4["catch"](19);
              errors.push(_context4.t5);

            case 86:
              _context4.prev = 86;

              if (!(executor != null)) {
                _context4.next = 96;
                break;
              }

              _context4.prev = 88;
              _context4.next = 91;
              return executor.dispose();

            case 91:
              _context4.next = 96;
              break;

            case 93:
              _context4.prev = 93;
              _context4.t6 = _context4["catch"](88);
              errors.push(_context4.t6);

            case 96:
              return _context4.finish(86);

            case 97:
              if (!(errors.length === 0)) {
                _context4.next = 101;
                break;
              }

              return _context4.abrupt("return", actualAssertion(completeTest, failTest, result, null, assertionNegated));

            case 101:
              summaryError = errors[0];

              if (errors.length > 1) {
                summaryError = new Error(errors.map(function (err) {
                  return err.message;
                }).join('\n'));
                summaryError.stack = errors.map(function (err) {
                  return err.stack;
                }).join('\n');
              } // eslint-disable-next-line no-console


              console.error(summaryError);
              return _context4.abrupt("return", actualAssertion(completeTest, failTest, null, errors[0], assertionNegated));

            case 105:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[19, 83, 86, 97], [24, 51], [54, 62], [65, 70], [73, 78], [88, 93]]);
    }));

    return function execute() {
      return _ref.apply(this, arguments);
    };
  }();

  setImmediate(execute);
  return {
    setAuthToken: setAuthToken,
    setSecretsManager: setSecretsManager,
    setAssertion: setAssertion,
    getAssertion: getAssertion,
    negateAssertion: negateAssertion,
    isAssertionNegated: isAssertionNegated,
    isExecuted: isExecuted,
    promise: promise
  };
};
//# sourceMappingURL=make-test-environment.js.map