"use strict";

exports.__esModule = true;
exports.mockQueryImplementation = void 0;

var _makeAssertions = require("./make-assertions");

var mockQueryImplementation = function mockQueryImplementation(context, modelName, resolverName, implementation) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Query implementation cannot be mocked if the test was executed.");
  }

  environment.mockQueryImplementation(modelName, resolverName, implementation);
  return (0, _makeAssertions.makeAssertions)(context);
};

exports.mockQueryImplementation = mockQueryImplementation;
//# sourceMappingURL=mock-query-implementation.js.map